--- /usr/share/acpi-support/policy-funcs	2010-11-17 09:56:51.000000000 +0100
+++ /tmp/policy-funcs	2010-11-18 00:00:27.000000000 +0100
@@ -1,11 +1,7 @@
 . /usr/share/acpi-support/power-funcs
 
 CheckUPowerPolicy() {
-	if pidof upowerd > /dev/null; then
-		return 0;
-	else
-		return 1;
-	fi
+	pidof upowerd >/dev/null
 }
 
 # The (not very aptly named) function CheckPolicy checks if the current X
@@ -17,27 +13,29 @@
 CheckPolicy() {
 	local PMS
 
+	# FIXME: several things in getXconsole may fail, but
+	#	 error handling missing :(
 	getXconsole
 	PMS="/usr/bin/gnome-power-manager /usr/bin/kpowersave /usr/bin/xfce4-power-manager"
 	PMS="$PMS /usr/bin/guidance-power-manager /usr/lib/dalston/dalston-power-applet"
-	if pidof -x $PMS > /dev/null ||
-	   { test "$XUSER" != "" && pidof dcopserver > /dev/null && test -x /usr/bin/dcop && /usr/bin/dcop --user $XUSER kded kded loadedModules | grep -q klaptopdaemon; } ||
-	   PowerDevilRunning ; then
-		return 0
-	else
-		return 1
-	fi
+	pidof -x $PMS >/dev/null ||
+	{ [ "$XUSER" ] &&
+	  pidof dcopserver > /dev/null &&
+	  [ -x /usr/bin/dcop ] &&
+	  /usr/bin/dcop --user $XUSER kded kded loadedModules | grep -q klaptopdaemon; } ||
+	PowerDevilRunning
 }
 
 PowerDevilRunning() {
-	test -x /usr/bin/dbus-send || return 1
-	
+	[ -x /usr/bin/dbus-send ] || return 1
+
+	local DBUS_SESS
 	for p in $(pidof kded4); do
-		test -r /proc/$p/environ || continue
-		local DBUS_SESS=$(cat /proc/$p/environ | grep -a -z "DBUS_SESSION_BUS_ADDRESS=")
-		test "$DBUS_SESS" != "" || continue
-		(su $(ps -o user= $p) -s /bin/sh -c "$DBUS_SESS dbus-send --print-reply --dest=org.kde.kded /kded org.kde.kded.loadedModules" | grep -q powerdevil) && return 0
+		[ -r /proc/$p/environ ] || continue
+		DBUS_SESS=$(grep -a -z "DBUS_SESSION_BUS_ADDRESS=" /proc/$p/environ || :)
+		[ "$DBUS_SESS" ] || continue
+		! su $(ps -o user= $p) -s /bin/sh -c "$DBUS_SESS dbus-send --print-reply --dest=org.kde.kded /kded org.kde.kded.loadedModules" | grep -q powerdevil || return 0
 	done
-	
+
 	return 1
 }
